# Function NormalizeTableRow

- NormalizeTableRow<T>(row, rowId): T

- Normalize the table row. Add the __rowId and metadata properties to the row.

  CAUTION: This function mutate the row object

  #### Type Parameters

  - T extends TableRowMetadata

    extends TableRowMetadata

  #### Parameters

  - row: RawTableRow<T>
  - rowId: string

  #### Returns T

  T the normalized row

  - Defined in packages/angular/material/table-system/src/lib/table-row-metadata.ts:31
- NormalizeTableRow<T>(row, rowIdMapper): T

- #### Type Parameters

  - T extends TableRowMetadata

  #### Parameters

  - row: RawTableRow<T>
  - rowIdMapper: RowIdMapperFunction<T>

  #### Returns T

  - Defined in packages/angular/material/table-system/src/lib/table-row-metadata.ts:35